/*!
  * Licensed Materials - Property of IBM
  * 5725N95, 5725P55, 5725N96
  * (C) Copyright IBM Corp. 1999, 2014.
  * US Government Users Restricted Rights- Use, duplication or disclosure
  * restricted by GSA ADP Schedule Contract with IBM Corp.
 */

 /* $Id: rlolistnav.js,v 1.1.2.1 2015/06/22 09:27:09 rakollep Exp $ */
 
ListController =
{
	evtData : {},
	current : null,
	noDataMessage : "No data is available.",
	init : function()
	{
		YAHOO.util.Event.addListener(document.body,"click",this.linkClicked,this,true);

		var vc = parent.ViewerController;
		
		vc.events.navigate.subscribe(this.handleNavigation,this,true);
		if (vc.current != null)
		{
			this.handleNavigation("navigation",[vc.current]);
		}
		vc.events.load.subscribe(this.updateList,this,true);
		vc.events.score.subscribe(this.updateList,this,true);
	},
	linkClicked : function(e)
	{
		var elm = YAHOO.util.Event.getTarget(e);

		var p = elm;
		var obj = null;
		while (obj == null && p != null)
		{
			obj = this.evtData[p.id];
			p = p.parentNode;
		}

		if (obj != null)
		{
			parent.ViewerController.navigateTo(obj);
		}

		YAHOO.util.Event.stopEvent(e);
	},
	handleNavigation : function(type, args)
	{
		var obj = args[0];
		var yd = YAHOO.util.Dom;
		
		this.createList(obj);
		
		yd.removeClass(yd.getElementsByClassName("navindon"),"navindon");
		
		var elmList = yd.getElementsByClassName("navlink");
		yd.removeClass(elmList,"navon");
		yd.addClass(elmList,"navoff");
		
		var elm;
		do
		{
			elm = yd.get("I"+obj.uniqueId);
			if (elm != null)
			{
				yd.addClass(elm,"navindon");
			}
			
			elm = yd.get("C"+obj.uniqueId);
			if (elm != null)
			{
				yd.replaceClass(elm,"navoff","navon");
			}
			
			elm = yd.get("A"+obj.uniqueId);
			if (elm)
			{
				if (!yd.hasClass(elm,"navhiston"))
				{
					yd.addClass(elm,"navhiston");
				}
				
				// auto scroll the topic into view
				if (yd.getRegion(elm).top < yd.getDocumentScrollTop())
				{
					// if the top of the element is above the visible area
					while (yd.getRegion(elm).top < yd.getDocumentScrollTop())
					{
						window.scrollTo(0,yd.getDocumentScrollTop()-1);
					}
				}
				else if (yd.getRegion(elm).bottom > (yd.getViewportHeight()+yd.getDocumentScrollTop()))
				{
					// if the bottom of the element is below the visible area
					while (yd.getRegion(elm).bottom > (yd.getViewportHeight()+yd.getDocumentScrollTop()))
					{
						window.scrollTo(0,yd.getDocumentScrollTop()+1);
					}
				}
			}
		}
		while ((obj = obj.parent) != null);
	},
	findLO : function(c)
	{
		var obj = null;
		if (c != null)
		{
			var t = c
			do
			{
				if (t.type == 3)
				{
					obj = t;
				}
			}
			while (obj == null && ((t = t.parent ) != null));
		}
		return obj;
	},
	createList : function(obj)
	{
		var yd = YAHOO.util.Dom;
		var vc = parent.ViewerController;

		var t = this.findLO(obj);
		if ((t == null && this.current != null) || (this.current == null || t != this.current))
		{
			// reset event tracking
			this.evtData = {};

			var root = this.current = t;
		
			var html = [];
			if (root != null)
			{
				if (root.children)
				{
					html.push("<table width=\"100%\" border=\"0\">");

					var c, indCls, accessCls, lnkCls;
					for (var i=0; i<root.children.length; i++)
					{
						c = root.children[i];
						
						if (!vc.isRemoved(c))
						{
							this.evtData["C"+c.uniqueId] = c;
							
							lnkCls = ["navlink"];

							if (!vc.isEnabled(c))
							{
								lnkCls.push("disabled");
							}

							if (vc.isIdentified(c))
							{
								lnkCls.push("satisfied");
							}
							
							html.push("<tr>"+
										"<td><div id=\"I"+c.uniqueId+"\" class=\"navind\"></div></td>"+
										"<td><a id=\"C"+c.uniqueId+"\" class=\""+lnkCls.join(" ")+"\" href=\"#\">"+c.label+"</a></td>");
										
							if (this.statusEnabled)
							{
								accessCls = (vc.isAccessed(c)) ? " navhiston" :  "";
								html.push("<td><div id=\"A"+c.uniqueId+"\" class=\"navhist"+accessCls+"\"></div></td>");
							}

							html.push("</tr>");
							html.push("<tr><td height=\"6\"></td></tr>");
							
						}
					}
					html.push("</table>");
				}
				else
				{
					html.push("<a class=\"navlink\" href=\"#\" onclick=\"return false;\">"+this.noDataMessage+"</a>");
				}
			}

			yd.get("navarea").innerHTML = html.join("");
		}
	},
	updateList : function(type, args)
	{
		if (this.current != null)
		{
			var yd = YAHOO.util.Dom;
			var vc = parent.ViewerController;
			
			var c, elm;
			for (var i=0; i<this.current.children.length; i++)
			{
				c = this.current.children[i];
				elm = yd.get("C"+c.uniqueId);
				if (vc.isEnabled(c))
				{
					yd.removeClass(elm,"disabled");
					if (vc.isIdentified(c))
					{
						yd.addClass(elm,"satisfied");
					}
					else
					{
						yd.removeClass(elm,"satisfied");
					}
				}
			}
		}
	}
}